##// END OF EJS Templates
copies: calculate mergecopies() based on pathcopies()...
copies: calculate mergecopies() based on pathcopies() When copies are stored in changesets, we need a changeset-centric version of mergecopies() just like we have a changeset-centric version of pathcopies(). I think the natural way of thinking about mergecopies() is in terms of pathcopies() from the base to each of the commits. So if we can rewrite mergecopies() based on two such pathcopies() calls, we'll get the changeset-centric version for free. That's what this patch does. A nice bonus is that it ends up being a lot simpler. mergecopies() has accumulated a lot of technical debt over time. One good example is the code for dealing with grafts (the "partial/incomplete/dirty" stuff). Since pathcopies() already deals with backwards renames and ping-pong renames, we get that for free. I've run tests with hard-coded debug logging for "fullcopy" and while I haven't looked at every difference it produces, all the ones I have looked at seemed reasonable to me. I'm a little surprised that no more tests fail when run with '--extra-config-opt experimental.copies.read-from=compatibility' compared to before this patch. This patch also fixes the broken cases in test-annotate.t and test-fastannotate.t. It also enables the part of test-copies.t that was previously disabled exactly because mergecopies() needed to get a changeset-centric version. One drawback of the rewritten code is that we may now make remotefilelog prefetch more files. We used to prefetch files that were unique to either side of the merge compared to the other. We now prefetch files that are unique to either side of the merge compared to the base. This means that if you added the same file to each side, we would not prefetch it before, but we would now. Such cases are probably quite rare, but one likely scenario where they happen is when moving from a commit to its successor (or the other way around). The user will probably already have the files in the cache in such cases, so it's probably not a big deal. Some timings for calculating mergecopies between two revisions (revisions shown on each line, all using the common ancestor as base): In the hg repo: 4.8 4.9: 0.21s -> 0.21s 4.0 4.8: 0.35s -> 0.63s In and old copy of the mozilla-unified repo: FIREFOX_BETA_60_BASE^ FIREFOX_BETA_60_BASE: 0.82s -> 0.82s FIREFOX_NIGHTLY_59_END FIREFOX_BETA_60_BASE: 2.5s -> 2.6s FIREFOX_BETA_59_END FIREFOX_BETA_60_BASE: 3.9s -> 4.1s FIREFOX_AURORA_50_BASE FIREFOX_BETA_60_BASE: 31s -> 33s So it's measurably slower in most cases. The most significant difference is in the hg repo between revisions 4.0 and 4.8. In that case it seems to come from the fact that pathcopies() uses fctx.isintroducedafter() (in _tracefile), while the old mergecopies() used fctx.linkrev() (in _checkcopies()). That results in a single call to filectx._adjustlinkrev(), which is responsible for the entire difference in time (in my repo). So we pay a performance penalty but we get more correct code (see change in test-mv-cp-st-diff.t). Deleting the "== f.filenode()" in _tracefile() recovers the lost performance in the hg repo. There were are few other optimizations in _checkcopies() that I could not measure any impact from. One was from the "seen" set. Another was from a "continue" when the file was not in the destination manifest (corresponding to "am" in _tracefile). Also note that merge copies are not calculated when updating with a clean working copy, which is probably the most common case. I therefore think the much simpler code is worth the slowdown. Differential Revision: https://phab.mercurial-scm.org/D6255

File last commit:

r26781:1aee2ab0 default
r42408:57203e02 default
Show More
hgeditor
56 lines | 1.2 KiB | text/plain | TextLexer
Thomas Arendsen Hein
Remove bashisms and use /bin/sh instead of /bin/bash....
r544 #!/bin/sh
mpm@selenic.com
Add $HGEDITOR hook and example script...
r186 #
Benoit Boissinot
remove the gpg stuff from hgeditor (superseded by the signing extension)...
r1599 # This is an example of using HGEDITOR to create of diff to review the
Mads Kiilerich
spelling: trivial spell checking
r26781 # changes while committing.
Matt Mackall
Turn off signing with hgeditor by default...
r684
Radoslaw "AstralStorm" Szkodzinski
hgeditor: Remove EMAIL default for HGUSER, comment editor selection ...
r666 # If you want to pass your favourite editor some other parameters
# only for Mercurial, modify this:
Thomas Arendsen Hein
Replaced mktemp and usage of ${par:=word}.
r796 case "${EDITOR}" in
"")
EDITOR="vi"
;;
Thomas Arendsen Hein
Improved hgeditor:...
r348 emacs)
EDITOR="$EDITOR -nw"
;;
gvim|vim)
EDITOR="$EDITOR -f -o"
;;
esac
Thomas Arendsen Hein
Replaced mktemp and usage of ${par:=word}.
r796
HGTMP=""
cleanup_exit() {
rm -rf "$HGTMP"
}
Thomas Arendsen Hein
Fixes and cleanups to hgeditor:...
r754 # Remove temporary files even if we get interrupted
Thomas Arendsen Hein
Cleaned up trap handling:...
r831 trap "cleanup_exit" 0 # normal exit
Javi Merino
Fixed a bashism with trap numbers in hgeditor....
r11190 trap "exit 255" HUP INT QUIT ABRT TERM
Thomas Arendsen Hein
Replaced mktemp and usage of ${par:=word}.
r796
Javi Merino
Fixed a bashism with the use of $RANDOM in hgeditor....
r11266 HGTMP=$(mktemp -d ${TMPDIR-/tmp}/hgeditor.XXXXXX)
[ x$HGTMP != x -a -d $HGTMP ] || {
echo "Could not create temporary directory! Exiting." 1>&2
exit 1
Thomas Arendsen Hein
Replaced mktemp and usage of ${par:=word}.
r796 }
Thomas Arendsen Hein
Fixes and cleanups to hgeditor:...
r754 (
grep '^HG: changed' "$1" | cut -b 13- | while read changed; do
Thomas Arendsen Hein
hgeditor: Use $HG to run 'hg diff' (see 849f011dbf79)
r4687 "$HG" diff "$changed" >> "$HGTMP/diff"
Thomas Arendsen Hein
Fixes and cleanups to hgeditor:...
r754 done
)
Thomas Arendsen Hein
Improved hgeditor:...
r348
Benoit Boissinot
remove the gpg stuff from hgeditor (superseded by the signing extension)...
r1599 cat "$1" > "$HGTMP/msg"
Matt Mackall
Turn off signing with hgeditor by default...
r684
Will Maier
Find the system's MD5 binary....
r3025 MD5=$(which md5sum 2>/dev/null) || \
Thomas Arendsen Hein
Kill trailing spaces
r4659 MD5=$(which md5 2>/dev/null)
Will Maier
Find the system's MD5 binary....
r3025 [ -x "${MD5}" ] && CHECKSUM=`${MD5} "$HGTMP/msg"`
Thomas Arendsen Hein
Don't show the diff in hgeditor if there are no changes in file contents.
r1009 if [ -s "$HGTMP/diff" ]; then
$EDITOR "$HGTMP/msg" "$HGTMP/diff" || exit $?
else
$EDITOR "$HGTMP/msg" || exit $?
fi
Will Maier
Find the system's MD5 binary....
r3025 [ -x "${MD5}" ] && (echo "$CHECKSUM" | ${MD5} -c >/dev/null 2>&1 && exit 13)
Thomas Arendsen Hein
Fixes and cleanups to hgeditor:...
r754
Benoit Boissinot
remove the gpg stuff from hgeditor (superseded by the signing extension)...
r1599 mv "$HGTMP/msg" "$1"
Thomas Arendsen Hein
Improved hgeditor:...
r348
Thomas Arendsen Hein
Cleaned up trap handling:...
r831 exit $?